---
layout: feature-kubernetes
title: GitLab Kubernetes Integration
description: GitLab’s Kubernetes Integration lets you build, test, deploy, and run your app at scale.
suppress_header: true
extra_css:
  - gitlab-feature-landing-page.css
  - features.css
  - kubernetes.css
extra_js:
  - all-clickable.js
---

.wrapper.gitlab-ee-page
  = partial "includes/features/gitlab-ee-nav"
  .image-title
    .color-bg
      %div
        %h1 GitLab + Kubernetes
        %h3#ci-subt Everything you need to build, test, deploy, and run your app at scale
  .sub-wrapper
    .container
      .row.advantages
        .col-xs-12.col-md-10.col-md-offset-1
          %h2 The best solution for cloud native development
          %p.overview
            Cloud native applications are the future of software development.
            Container-packaged, dynamically managed, and microservice-oriented,
            cloud native systems enable faster development velocity while
            maintaining operational stability.
          %p.overview
            GitLab is a single application with everything you need for
            %a{ href: "/stages-devops-lifecycle/" } end-to-end software development and operations.
            From issue tracking and source code management to CI/CD and
            monitoring, having it all in one place simplifies toolchain
            complexity and speeds up cycle times. With a
            %a{ href: "https://docs.gitlab.com/ee/user/project/container_registry.html", target: "_blank" }built-in container registry
            and
            %a{ href: "https://docs.gitlab.com/ee/user/project/clusters/index.html", target: "_blank" }Kubernetes integration,
            GitLab makes it easier than ever to get started with containers
            and cloud native development.
          %a.btn.cta-btn.white-with-border{ href: "/2017/11/30/containers-kubernetes-basics/" } What is Kubernetes?
      %hr.divider/

      .row
        .hidden-xs.hidden-sm.col-md-4
          .ee-feature-icon
            %img.hidden-xs{alt: "", src: "/images/features/kubernetes-logo.png"}/
        .col-xs-12.col-md-6.col-md-offset-1
          %h2  Kubernetes Integration
          %p.overview
            While you can use GitLab CI/CD to deploy your apps almost anywhere from bare metal to VMs, GitLab is designed for Kubernetes.
            %a{ href: "https://docs.gitlab.com/ee/user/project/clusters/index.html", target: "_blank" }The Kubernetes integration
            gives you access to advanced features like:
          %ul
            %li
              %a{ href: "https://docs.gitlab.com/ee/user/project/deploy_boards.html", target: "_blank" }Deploy Boards
            %li
              %a{ href: "https://docs.gitlab.com/ee/user/project/canary_deployments.html", target: "_blank" }Canary Deployments
            %li
              %a{ href: "https://docs.gitlab.com/ee/user/project/integrations/prometheus_library/kubernetes.html", target: "_blank" }Kubernetes monitoring
            %li
              %a{ href: "https://docs.gitlab.com/ee/topics/autodevops/", target: "_blank" }Auto DevOps
            %li
              %a{ href: "https://docs.gitlab.com/ee/administration/integration/terminal.html", target: "_blank" }Web terminals
      %hr.divider/

      .row
        .col-xs-12.col-md-6.col-md-offset-1
          %h2 Use GitLab to test and deploy your app on Kubernetes
          %p.overview
            %a{ href: "/features/gitlab-ci-cd/" }GitLab CI/CD
            let’s you easily manage deployments to multiple environments. Run
            automated tests in parallel with auto-scaling
            %a{ href: "https://docs.gitlab.com/runner/", target: "_blank" }GitLab Runners.
            Manually test changes in a live, production-like environment before
            merging code with
            %a{ href: "/product/review-apps/" }Review Apps.
            Runners, Reviews Apps and your own application can be deployed to
            your Kubernetes cluster or any environment you choose.
          %a.btn.cta-btn.white-with-border{ href: "/solutions/google-cloud-platform/" } Deploy on Google Cloud Platform
        .col-md-4.col-md-offset-1.hidden-xs.hidden-sm
          .ee-feature-icon
            = icon("home/icon-step-6")
      %hr.divider/

      .row
        .col-xs-12.col-md-6.col-md-push-6
          %h2  Use the same tool that tests Kubernetes
          %p.overview
            Prometheus, CoreDNS, and Kubernetes itself are built, deployed, and tested by
            %a{ href: "https://www.cncf.io/", target: "_blank" }CNCF
            using GitLab. They deploy multiple projects to multiple clouds with end-to-end testing using GitLab multi-project deploy boards to monitor progress.
          %a.btn.cta-btn.white-with-border{ href: "/customers/cncf" } Learn more

        .col-xs-12.col-md-5.col-md-pull-6
          .embed-responsive.embed-responsive-16by9
            %iframe{ src: "https://www.youtube.com/embed/Jc5EJVK7ZZk?start=372", allowfullscreen: "allowfullscreen" }
      %hr.divider/

      = partial "includes/blog/try"

%section.feature-group.u-subtle-bg
  .container
    .row.flex-row
      .col-sm-6.col-md-3.col-lg-3
        .feature.tile.js-all-clickable
          .feature-media
            = image_tag "/images/feature-thumbs/feature-thumb-devops.png", alt: 'DevOps', srcset: "/images/feature-thumbs/feature-thumb-devops_2x.png 2x"
          .feature-body
            -#%h3.feature-label Docs
            %h2.feature-title Auto DevOps Documentation
            %p.feature-description
            %a.feature-more{ href: "https://docs.gitlab.com/ee/topics/autodevops/index.html", target: "_blank" } Read more

      .col-sm-6.col-md-3.col-lg-3
        .feature.tile.js-all-clickable
          .feature-media
            = image_tag "/images/feature-thumbs/feature-thumb-how-to-create-ci-cd-pipeline-with-autodeploy-to-kubernetes-using-gitlab-and-helm.png", alt: 'Create a CI/CD pipeline blog post', srcset: "/images/feature-thumbs/feature-thumb-how-to-create-ci-cd-pipeline-with-autodeploy-to-kubernetes-using-gitlab-and-helm_2x.png 2x"
          .feature-body
            -#%h3.feature-label Blog
            %h2.feature-title Create a CI/CD Pipeline with Auto Deploy
            %p.feature-description
            %a.feature-more{href: "/2017/09/21/how-to-create-ci-cd-pipeline-with-autodeploy-to-kubernetes-using-gitlab-and-helm/"} Read more

      .col-sm-6.col-md-3.col-lg-3
        .feature.tile.js-all-clickable
          .feature-media
            = image_tag "/images/feature-thumbs/feature-thumb-gitlab-kubernetes.png", alt: 'GitLab & Kubernetes', srcset: "/images/feature-thumbs/feature-thumb-gitlab-kubernetes_2x.png 2x"
          .feature-body
            -#%h3.feature-label Docs
            %h2.feature-title Install GitLab on Kubernetes
            %p.feature-description
            %a.feature-more{ href: "https://docs.gitlab.com/ee/install/kubernetes/", target: "_blank" } Read more

      .col-sm-6.col-md-3.col-lg-3
        .feature.tile.js-all-clickable
          .feature-media
            = image_tag "/images/feature-thumbs/feature-thumb-webcast.png", alt: 'GitLab Webcast', srcset: "/images/feature-thumbs/feature-thumb-webcast_2x.png 2x"
          .feature-body
            -#%h3.feature-label Resource
            %h2.feature-title Cloud Native Webinar
            %p.feature-description
            %a.feature-more{ href: "/2017/04/18/cloud-native-demo/", target: "_blank" } Watch now
